'*******************************************************************************
'
' PREVISION
'
'*******************************************************************************

type TPosition
  as byte valeur (1 to 8, 1 to 8)
  as byte balance
  as string liste
  as ubyte n' nombre de possibilits
end type

dim shared as TPosition Instant1()
dim shared as TPosition Instant2()

'*******************************************************************************

declare sub Prevision1 (oc() as byte,_
                        tr   as byte,_
                        lp   as string,_
                        np   as ubyte,_
                  byref npmx as ubyte)

declare sub Prevision2 (Inst1() as TPosition,_
                        tr      as byte,_
                        np0     as ubyte,_
                        npm1    as ubyte,_
                  byref npm2    as ubyte)

'*******************************************************************************

sub Prevision1 (oc() as byte,_
                tr   as byte,_
                lp   as string,_
                np   as ubyte,_
          byref npmx as ubyte)
  
  dim as byte x1,y1,x2,y2
  dim as string coup
  
  npmx=0
  
  for i as ubyte=1 to np
    
    coup=mid(lp,1+4*(i-1),4)
    
    x1=coup[0]-96
    y1=coup[1]-48
    x2=coup[2]-96
    y2=coup[3]-48
    
    Instant1(i).balance=0
    
    for x as byte=1 to 8
      for y as byte=1 to 8
        Instant1(i).valeur(x,y)=oc(x,y)
      next y
    next x
    
    ' Dplacement de la Tour en cas de roque
    if abs(Instant1(i).valeur(x1,y1))=Roi then
      select case coup
      case "e1c1"
        Instant1(i).valeur(1,1)=Vide
        Instant1(i).valeur(4,1)=Tour
      case "e1g1"
        Instant1(i).valeur(8,1)=Vide
        Instant1(i).valeur(6,1)=Tour
      case "e8c8"
        Instant1(i).valeur(1,8)=Vide
        Instant1(i).valeur(4,8)=-1*Tour
      case "e8g8"
        Instant1(i).valeur(8,8)=Vide
        Instant1(i).valeur(6,8)=-1*Tour
      end select
    end if
    ' Effacement du Pion pris "en passant"
    if (abs(Instant1(i).valeur(x1,y1))=Pion) andalso (x2<>x1) then
      if (Instant1(i).valeur(x2,y2)=Vide) then
        Instant1(i).valeur(x2,y1)=Vide
      end if
    end if
    ' Promotion du Pion en Dame
    if (abs(Instant1(i).valeur(x1,y1))=Pion) andalso ((y2=8) or (y2=1)) then
      
      Instant1(i).valeur(x1,y1)=Dame*Instant1(i).valeur(x1,y1)
      
    end if
    
    Instant1(i).valeur(x2,y2)=Instant1(i).valeur(x1,y1)
    Instant1(i).valeur(x1,y1)=Vide
    
    for x as byte=1 to 8
      for y as byte=1 to 8
        Instant1(i).balance+=Instant1(i).valeur(x,y)
      next y
    next x    
    
    CalculPossiblesCourt (Instant1(i).valeur(), -1*tr,_
                          Instant1(i).liste, Instant1(i).n)
                          
    if Instant1(i).n>npmx then npmx=Instant1(i).n
  next i
  
end sub

'*******************************************************************************

sub Prevision2 (Inst1() as TPosition,_
                tr      as byte,_
                np0     as ubyte,_
                npm1    as ubyte,_
          byref npm2    as ubyte)
  
  dim as byte x1,y1,x2,y2
  dim as string coup
  
  npm2=0
  
  for i as ubyte=1 to np0
    for j as ubyte=1 to npm1
      
      if j>len(Inst1(i).liste)\4 then continue for
      
      coup=mid(Inst1(i).liste,1+4*(j-1),4)
      
      x1=coup[0]-96
      y1=coup[1]-48
      x2=coup[2]-96
      y2=coup[3]-48
      
      Instant2(i,j).balance=0
      
      for x as byte=1 to 8
        for y as byte=1 to 8
          Instant2(i,j).valeur(x,y)=Inst1(i).valeur(x,y)
        next y
      next x
      
      'Promotion du Pion en Dame
      if Abs(Instant2(i,j).valeur(x1,y1))=Pion andalso ((y2=8) or (y2=1)) then
        Instant2(i,j).valeur(x1,y1)=Dame*Instant2(i,j).valeur(x1,y1)
      end if
      
      Instant2(i,j).valeur(x2,y2)=Instant2(i,j).valeur(x1,y1)
      Instant2(i,j).valeur(x1,y1)=Vide
      
      for x as byte=1 to 8
        for y as byte=1 to 8
          Instant2(i,j).balance+=Instant2(i,j).valeur(x,y)
        next y
      next x
    
      CalculPossiblesCourt (Instant2(i,j).valeur(), tr,_
                          Instant2(i,j).liste, Instant2(i,j).n)
      
      if Instant2(i,j).n>npm2 then npm2=Instant2(i,j).n
      
    next j
  next i
  
end sub

'*******************************************************************************